// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"gochassis/ent/predicate"
	"gochassis/ent/profile"
	"gochassis/ent/schema"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// PostUpdate is the builder for updating Post entities.
type PostUpdate struct {
	config
	hooks    []Hook
	mutation *PostMutation
}

// Where appends a list predicates to the PostUpdate builder.
func (pu *PostUpdate) Where(ps ...predicate.Post) *PostUpdate {
	pu.mutation.Where(ps...)
	return pu
}

// SetImage sets the "image" field.
func (pu *PostUpdate) SetImage(s string) *PostUpdate {
	pu.mutation.SetImage(s)
	return pu
}

// SetContent sets the "content" field.
func (pu *PostUpdate) SetContent(s string) *PostUpdate {
	pu.mutation.SetContent(s)
	return pu
}

// SetProfileDisplayname sets the "profile_displayname" field.
func (pu *PostUpdate) SetProfileDisplayname(s string) *PostUpdate {
	pu.mutation.SetProfileDisplayname(s)
	return pu
}

// SetProfileBirthYear sets the "profile_birth_year" field.
func (pu *PostUpdate) SetProfileBirthYear(i int16) *PostUpdate {
	pu.mutation.ResetProfileBirthYear()
	pu.mutation.SetProfileBirthYear(i)
	return pu
}

// SetNillableProfileBirthYear sets the "profile_birth_year" field if the given value is not nil.
func (pu *PostUpdate) SetNillableProfileBirthYear(i *int16) *PostUpdate {
	if i != nil {
		pu.SetProfileBirthYear(*i)
	}
	return pu
}

// AddProfileBirthYear adds i to the "profile_birth_year" field.
func (pu *PostUpdate) AddProfileBirthYear(i int16) *PostUpdate {
	pu.mutation.AddProfileBirthYear(i)
	return pu
}

// ClearProfileBirthYear clears the value of the "profile_birth_year" field.
func (pu *PostUpdate) ClearProfileBirthYear() *PostUpdate {
	pu.mutation.ClearProfileBirthYear()
	return pu
}

// SetProfileGender sets the "profile_gender" field.
func (pu *PostUpdate) SetProfileGender(s string) *PostUpdate {
	pu.mutation.SetProfileGender(s)
	return pu
}

// SetNillableProfileGender sets the "profile_gender" field if the given value is not nil.
func (pu *PostUpdate) SetNillableProfileGender(s *string) *PostUpdate {
	if s != nil {
		pu.SetProfileGender(*s)
	}
	return pu
}

// ClearProfileGender clears the value of the "profile_gender" field.
func (pu *PostUpdate) ClearProfileGender() *PostUpdate {
	pu.mutation.ClearProfileGender()
	return pu
}

// SetCoordinates sets the "coordinates" field.
func (pu *PostUpdate) SetCoordinates(s *schema.Point) *PostUpdate {
	pu.mutation.SetCoordinates(s)
	return pu
}

// SetCreatedAt sets the "created_at" field.
func (pu *PostUpdate) SetCreatedAt(t time.Time) *PostUpdate {
	pu.mutation.SetCreatedAt(t)
	return pu
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (pu *PostUpdate) SetNillableCreatedAt(t *time.Time) *PostUpdate {
	if t != nil {
		pu.SetCreatedAt(*t)
	}
	return pu
}

// SetUpdatedAt sets the "updated_at" field.
func (pu *PostUpdate) SetUpdatedAt(t time.Time) *PostUpdate {
	pu.mutation.SetUpdatedAt(t)
	return pu
}

// SetDeletedAt sets the "deleted_at" field.
func (pu *PostUpdate) SetDeletedAt(t time.Time) *PostUpdate {
	pu.mutation.SetDeletedAt(t)
	return pu
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (pu *PostUpdate) SetNillableDeletedAt(t *time.Time) *PostUpdate {
	if t != nil {
		pu.SetDeletedAt(*t)
	}
	return pu
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (pu *PostUpdate) ClearDeletedAt() *PostUpdate {
	pu.mutation.ClearDeletedAt()
	return pu
}

// SetReplyTo sets the "reply_to" field.
func (pu *PostUpdate) SetReplyTo(i int) *PostUpdate {
	pu.mutation.SetReplyTo(i)
	return pu
}

// SetNillableReplyTo sets the "reply_to" field if the given value is not nil.
func (pu *PostUpdate) SetNillableReplyTo(i *int) *PostUpdate {
	if i != nil {
		pu.SetReplyTo(*i)
	}
	return pu
}

// ClearReplyTo clears the value of the "reply_to" field.
func (pu *PostUpdate) ClearReplyTo() *PostUpdate {
	pu.mutation.ClearReplyTo()
	return pu
}

// AddChatRoomIDs adds the "chat_rooms" edge to the ChatRoom entity by IDs.
func (pu *PostUpdate) AddChatRoomIDs(ids ...int) *PostUpdate {
	pu.mutation.AddChatRoomIDs(ids...)
	return pu
}

// AddChatRooms adds the "chat_rooms" edges to the ChatRoom entity.
func (pu *PostUpdate) AddChatRooms(c ...*ChatRoom) *PostUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pu.AddChatRoomIDs(ids...)
}

// SetPostedByID sets the "posted_by" edge to the Profile entity by ID.
func (pu *PostUpdate) SetPostedByID(id int) *PostUpdate {
	pu.mutation.SetPostedByID(id)
	return pu
}

// SetPostedBy sets the "posted_by" edge to the Profile entity.
func (pu *PostUpdate) SetPostedBy(p *Profile) *PostUpdate {
	return pu.SetPostedByID(p.ID)
}

// AddLikedByIDs adds the "liked_by" edge to the Profile entity by IDs.
func (pu *PostUpdate) AddLikedByIDs(ids ...int) *PostUpdate {
	pu.mutation.AddLikedByIDs(ids...)
	return pu
}

// AddLikedBy adds the "liked_by" edges to the Profile entity.
func (pu *PostUpdate) AddLikedBy(p ...*Profile) *PostUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.AddLikedByIDs(ids...)
}

// SetReplyToEdgeID sets the "reply_to_edge" edge to the Post entity by ID.
func (pu *PostUpdate) SetReplyToEdgeID(id int) *PostUpdate {
	pu.mutation.SetReplyToEdgeID(id)
	return pu
}

// SetNillableReplyToEdgeID sets the "reply_to_edge" edge to the Post entity by ID if the given value is not nil.
func (pu *PostUpdate) SetNillableReplyToEdgeID(id *int) *PostUpdate {
	if id != nil {
		pu = pu.SetReplyToEdgeID(*id)
	}
	return pu
}

// SetReplyToEdge sets the "reply_to_edge" edge to the Post entity.
func (pu *PostUpdate) SetReplyToEdge(p *Post) *PostUpdate {
	return pu.SetReplyToEdgeID(p.ID)
}

// AddReplyIDs adds the "replies" edge to the Post entity by IDs.
func (pu *PostUpdate) AddReplyIDs(ids ...int) *PostUpdate {
	pu.mutation.AddReplyIDs(ids...)
	return pu
}

// AddReplies adds the "replies" edges to the Post entity.
func (pu *PostUpdate) AddReplies(p ...*Post) *PostUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.AddReplyIDs(ids...)
}

// Mutation returns the PostMutation object of the builder.
func (pu *PostUpdate) Mutation() *PostMutation {
	return pu.mutation
}

// ClearChatRooms clears all "chat_rooms" edges to the ChatRoom entity.
func (pu *PostUpdate) ClearChatRooms() *PostUpdate {
	pu.mutation.ClearChatRooms()
	return pu
}

// RemoveChatRoomIDs removes the "chat_rooms" edge to ChatRoom entities by IDs.
func (pu *PostUpdate) RemoveChatRoomIDs(ids ...int) *PostUpdate {
	pu.mutation.RemoveChatRoomIDs(ids...)
	return pu
}

// RemoveChatRooms removes "chat_rooms" edges to ChatRoom entities.
func (pu *PostUpdate) RemoveChatRooms(c ...*ChatRoom) *PostUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pu.RemoveChatRoomIDs(ids...)
}

// ClearPostedBy clears the "posted_by" edge to the Profile entity.
func (pu *PostUpdate) ClearPostedBy() *PostUpdate {
	pu.mutation.ClearPostedBy()
	return pu
}

// ClearLikedBy clears all "liked_by" edges to the Profile entity.
func (pu *PostUpdate) ClearLikedBy() *PostUpdate {
	pu.mutation.ClearLikedBy()
	return pu
}

// RemoveLikedByIDs removes the "liked_by" edge to Profile entities by IDs.
func (pu *PostUpdate) RemoveLikedByIDs(ids ...int) *PostUpdate {
	pu.mutation.RemoveLikedByIDs(ids...)
	return pu
}

// RemoveLikedBy removes "liked_by" edges to Profile entities.
func (pu *PostUpdate) RemoveLikedBy(p ...*Profile) *PostUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.RemoveLikedByIDs(ids...)
}

// ClearReplyToEdge clears the "reply_to_edge" edge to the Post entity.
func (pu *PostUpdate) ClearReplyToEdge() *PostUpdate {
	pu.mutation.ClearReplyToEdge()
	return pu
}

// ClearReplies clears all "replies" edges to the Post entity.
func (pu *PostUpdate) ClearReplies() *PostUpdate {
	pu.mutation.ClearReplies()
	return pu
}

// RemoveReplyIDs removes the "replies" edge to Post entities by IDs.
func (pu *PostUpdate) RemoveReplyIDs(ids ...int) *PostUpdate {
	pu.mutation.RemoveReplyIDs(ids...)
	return pu
}

// RemoveReplies removes "replies" edges to Post entities.
func (pu *PostUpdate) RemoveReplies(p ...*Post) *PostUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.RemoveReplyIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (pu *PostUpdate) Save(ctx context.Context) (int, error) {
	pu.defaults()
	return withHooks[int, PostMutation](ctx, pu.sqlSave, pu.mutation, pu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (pu *PostUpdate) SaveX(ctx context.Context) int {
	affected, err := pu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (pu *PostUpdate) Exec(ctx context.Context) error {
	_, err := pu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pu *PostUpdate) ExecX(ctx context.Context) {
	if err := pu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (pu *PostUpdate) defaults() {
	if _, ok := pu.mutation.UpdatedAt(); !ok {
		v := post.UpdateDefaultUpdatedAt()
		pu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (pu *PostUpdate) check() error {
	if v, ok := pu.mutation.Image(); ok {
		if err := post.ImageValidator(v); err != nil {
			return &ValidationError{Name: "image", err: fmt.Errorf(`ent: validator failed for field "Post.image": %w`, err)}
		}
	}
	if v, ok := pu.mutation.Content(); ok {
		if err := post.ContentValidator(v); err != nil {
			return &ValidationError{Name: "content", err: fmt.Errorf(`ent: validator failed for field "Post.content": %w`, err)}
		}
	}
	if v, ok := pu.mutation.ProfileDisplayname(); ok {
		if err := post.ProfileDisplaynameValidator(v); err != nil {
			return &ValidationError{Name: "profile_displayname", err: fmt.Errorf(`ent: validator failed for field "Post.profile_displayname": %w`, err)}
		}
	}
	if _, ok := pu.mutation.PostedByID(); pu.mutation.PostedByCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Post.posted_by"`)
	}
	return nil
}

func (pu *PostUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := pu.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(post.Table, post.Columns, sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt))
	if ps := pu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := pu.mutation.Image(); ok {
		_spec.SetField(post.FieldImage, field.TypeString, value)
	}
	if value, ok := pu.mutation.Content(); ok {
		_spec.SetField(post.FieldContent, field.TypeString, value)
	}
	if value, ok := pu.mutation.ProfileDisplayname(); ok {
		_spec.SetField(post.FieldProfileDisplayname, field.TypeString, value)
	}
	if value, ok := pu.mutation.ProfileBirthYear(); ok {
		_spec.SetField(post.FieldProfileBirthYear, field.TypeInt16, value)
	}
	if value, ok := pu.mutation.AddedProfileBirthYear(); ok {
		_spec.AddField(post.FieldProfileBirthYear, field.TypeInt16, value)
	}
	if pu.mutation.ProfileBirthYearCleared() {
		_spec.ClearField(post.FieldProfileBirthYear, field.TypeInt16)
	}
	if value, ok := pu.mutation.ProfileGender(); ok {
		_spec.SetField(post.FieldProfileGender, field.TypeString, value)
	}
	if pu.mutation.ProfileGenderCleared() {
		_spec.ClearField(post.FieldProfileGender, field.TypeString)
	}
	if value, ok := pu.mutation.Coordinates(); ok {
		_spec.SetField(post.FieldCoordinates, field.TypeOther, value)
	}
	if value, ok := pu.mutation.CreatedAt(); ok {
		_spec.SetField(post.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := pu.mutation.UpdatedAt(); ok {
		_spec.SetField(post.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := pu.mutation.DeletedAt(); ok {
		_spec.SetField(post.FieldDeletedAt, field.TypeTime, value)
	}
	if pu.mutation.DeletedAtCleared() {
		_spec.ClearField(post.FieldDeletedAt, field.TypeTime)
	}
	if pu.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedChatRoomsIDs(); len(nodes) > 0 && !pu.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.ChatRoomsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.PostedByCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.PostedByTable,
			Columns: []string{post.PostedByColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.PostedByIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.PostedByTable,
			Columns: []string{post.PostedByColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.LikedByCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedLikedByIDs(); len(nodes) > 0 && !pu.mutation.LikedByCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.LikedByIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.ReplyToEdgeCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.ReplyToEdgeTable,
			Columns: []string{post.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.ReplyToEdgeIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.ReplyToEdgeTable,
			Columns: []string{post.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedRepliesIDs(); len(nodes) > 0 && !pu.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RepliesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, pu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{post.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	pu.mutation.done = true
	return n, nil
}

// PostUpdateOne is the builder for updating a single Post entity.
type PostUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *PostMutation
}

// SetImage sets the "image" field.
func (puo *PostUpdateOne) SetImage(s string) *PostUpdateOne {
	puo.mutation.SetImage(s)
	return puo
}

// SetContent sets the "content" field.
func (puo *PostUpdateOne) SetContent(s string) *PostUpdateOne {
	puo.mutation.SetContent(s)
	return puo
}

// SetProfileDisplayname sets the "profile_displayname" field.
func (puo *PostUpdateOne) SetProfileDisplayname(s string) *PostUpdateOne {
	puo.mutation.SetProfileDisplayname(s)
	return puo
}

// SetProfileBirthYear sets the "profile_birth_year" field.
func (puo *PostUpdateOne) SetProfileBirthYear(i int16) *PostUpdateOne {
	puo.mutation.ResetProfileBirthYear()
	puo.mutation.SetProfileBirthYear(i)
	return puo
}

// SetNillableProfileBirthYear sets the "profile_birth_year" field if the given value is not nil.
func (puo *PostUpdateOne) SetNillableProfileBirthYear(i *int16) *PostUpdateOne {
	if i != nil {
		puo.SetProfileBirthYear(*i)
	}
	return puo
}

// AddProfileBirthYear adds i to the "profile_birth_year" field.
func (puo *PostUpdateOne) AddProfileBirthYear(i int16) *PostUpdateOne {
	puo.mutation.AddProfileBirthYear(i)
	return puo
}

// ClearProfileBirthYear clears the value of the "profile_birth_year" field.
func (puo *PostUpdateOne) ClearProfileBirthYear() *PostUpdateOne {
	puo.mutation.ClearProfileBirthYear()
	return puo
}

// SetProfileGender sets the "profile_gender" field.
func (puo *PostUpdateOne) SetProfileGender(s string) *PostUpdateOne {
	puo.mutation.SetProfileGender(s)
	return puo
}

// SetNillableProfileGender sets the "profile_gender" field if the given value is not nil.
func (puo *PostUpdateOne) SetNillableProfileGender(s *string) *PostUpdateOne {
	if s != nil {
		puo.SetProfileGender(*s)
	}
	return puo
}

// ClearProfileGender clears the value of the "profile_gender" field.
func (puo *PostUpdateOne) ClearProfileGender() *PostUpdateOne {
	puo.mutation.ClearProfileGender()
	return puo
}

// SetCoordinates sets the "coordinates" field.
func (puo *PostUpdateOne) SetCoordinates(s *schema.Point) *PostUpdateOne {
	puo.mutation.SetCoordinates(s)
	return puo
}

// SetCreatedAt sets the "created_at" field.
func (puo *PostUpdateOne) SetCreatedAt(t time.Time) *PostUpdateOne {
	puo.mutation.SetCreatedAt(t)
	return puo
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (puo *PostUpdateOne) SetNillableCreatedAt(t *time.Time) *PostUpdateOne {
	if t != nil {
		puo.SetCreatedAt(*t)
	}
	return puo
}

// SetUpdatedAt sets the "updated_at" field.
func (puo *PostUpdateOne) SetUpdatedAt(t time.Time) *PostUpdateOne {
	puo.mutation.SetUpdatedAt(t)
	return puo
}

// SetDeletedAt sets the "deleted_at" field.
func (puo *PostUpdateOne) SetDeletedAt(t time.Time) *PostUpdateOne {
	puo.mutation.SetDeletedAt(t)
	return puo
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (puo *PostUpdateOne) SetNillableDeletedAt(t *time.Time) *PostUpdateOne {
	if t != nil {
		puo.SetDeletedAt(*t)
	}
	return puo
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (puo *PostUpdateOne) ClearDeletedAt() *PostUpdateOne {
	puo.mutation.ClearDeletedAt()
	return puo
}

// SetReplyTo sets the "reply_to" field.
func (puo *PostUpdateOne) SetReplyTo(i int) *PostUpdateOne {
	puo.mutation.SetReplyTo(i)
	return puo
}

// SetNillableReplyTo sets the "reply_to" field if the given value is not nil.
func (puo *PostUpdateOne) SetNillableReplyTo(i *int) *PostUpdateOne {
	if i != nil {
		puo.SetReplyTo(*i)
	}
	return puo
}

// ClearReplyTo clears the value of the "reply_to" field.
func (puo *PostUpdateOne) ClearReplyTo() *PostUpdateOne {
	puo.mutation.ClearReplyTo()
	return puo
}

// AddChatRoomIDs adds the "chat_rooms" edge to the ChatRoom entity by IDs.
func (puo *PostUpdateOne) AddChatRoomIDs(ids ...int) *PostUpdateOne {
	puo.mutation.AddChatRoomIDs(ids...)
	return puo
}

// AddChatRooms adds the "chat_rooms" edges to the ChatRoom entity.
func (puo *PostUpdateOne) AddChatRooms(c ...*ChatRoom) *PostUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return puo.AddChatRoomIDs(ids...)
}

// SetPostedByID sets the "posted_by" edge to the Profile entity by ID.
func (puo *PostUpdateOne) SetPostedByID(id int) *PostUpdateOne {
	puo.mutation.SetPostedByID(id)
	return puo
}

// SetPostedBy sets the "posted_by" edge to the Profile entity.
func (puo *PostUpdateOne) SetPostedBy(p *Profile) *PostUpdateOne {
	return puo.SetPostedByID(p.ID)
}

// AddLikedByIDs adds the "liked_by" edge to the Profile entity by IDs.
func (puo *PostUpdateOne) AddLikedByIDs(ids ...int) *PostUpdateOne {
	puo.mutation.AddLikedByIDs(ids...)
	return puo
}

// AddLikedBy adds the "liked_by" edges to the Profile entity.
func (puo *PostUpdateOne) AddLikedBy(p ...*Profile) *PostUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.AddLikedByIDs(ids...)
}

// SetReplyToEdgeID sets the "reply_to_edge" edge to the Post entity by ID.
func (puo *PostUpdateOne) SetReplyToEdgeID(id int) *PostUpdateOne {
	puo.mutation.SetReplyToEdgeID(id)
	return puo
}

// SetNillableReplyToEdgeID sets the "reply_to_edge" edge to the Post entity by ID if the given value is not nil.
func (puo *PostUpdateOne) SetNillableReplyToEdgeID(id *int) *PostUpdateOne {
	if id != nil {
		puo = puo.SetReplyToEdgeID(*id)
	}
	return puo
}

// SetReplyToEdge sets the "reply_to_edge" edge to the Post entity.
func (puo *PostUpdateOne) SetReplyToEdge(p *Post) *PostUpdateOne {
	return puo.SetReplyToEdgeID(p.ID)
}

// AddReplyIDs adds the "replies" edge to the Post entity by IDs.
func (puo *PostUpdateOne) AddReplyIDs(ids ...int) *PostUpdateOne {
	puo.mutation.AddReplyIDs(ids...)
	return puo
}

// AddReplies adds the "replies" edges to the Post entity.
func (puo *PostUpdateOne) AddReplies(p ...*Post) *PostUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.AddReplyIDs(ids...)
}

// Mutation returns the PostMutation object of the builder.
func (puo *PostUpdateOne) Mutation() *PostMutation {
	return puo.mutation
}

// ClearChatRooms clears all "chat_rooms" edges to the ChatRoom entity.
func (puo *PostUpdateOne) ClearChatRooms() *PostUpdateOne {
	puo.mutation.ClearChatRooms()
	return puo
}

// RemoveChatRoomIDs removes the "chat_rooms" edge to ChatRoom entities by IDs.
func (puo *PostUpdateOne) RemoveChatRoomIDs(ids ...int) *PostUpdateOne {
	puo.mutation.RemoveChatRoomIDs(ids...)
	return puo
}

// RemoveChatRooms removes "chat_rooms" edges to ChatRoom entities.
func (puo *PostUpdateOne) RemoveChatRooms(c ...*ChatRoom) *PostUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return puo.RemoveChatRoomIDs(ids...)
}

// ClearPostedBy clears the "posted_by" edge to the Profile entity.
func (puo *PostUpdateOne) ClearPostedBy() *PostUpdateOne {
	puo.mutation.ClearPostedBy()
	return puo
}

// ClearLikedBy clears all "liked_by" edges to the Profile entity.
func (puo *PostUpdateOne) ClearLikedBy() *PostUpdateOne {
	puo.mutation.ClearLikedBy()
	return puo
}

// RemoveLikedByIDs removes the "liked_by" edge to Profile entities by IDs.
func (puo *PostUpdateOne) RemoveLikedByIDs(ids ...int) *PostUpdateOne {
	puo.mutation.RemoveLikedByIDs(ids...)
	return puo
}

// RemoveLikedBy removes "liked_by" edges to Profile entities.
func (puo *PostUpdateOne) RemoveLikedBy(p ...*Profile) *PostUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.RemoveLikedByIDs(ids...)
}

// ClearReplyToEdge clears the "reply_to_edge" edge to the Post entity.
func (puo *PostUpdateOne) ClearReplyToEdge() *PostUpdateOne {
	puo.mutation.ClearReplyToEdge()
	return puo
}

// ClearReplies clears all "replies" edges to the Post entity.
func (puo *PostUpdateOne) ClearReplies() *PostUpdateOne {
	puo.mutation.ClearReplies()
	return puo
}

// RemoveReplyIDs removes the "replies" edge to Post entities by IDs.
func (puo *PostUpdateOne) RemoveReplyIDs(ids ...int) *PostUpdateOne {
	puo.mutation.RemoveReplyIDs(ids...)
	return puo
}

// RemoveReplies removes "replies" edges to Post entities.
func (puo *PostUpdateOne) RemoveReplies(p ...*Post) *PostUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.RemoveReplyIDs(ids...)
}

// Where appends a list predicates to the PostUpdate builder.
func (puo *PostUpdateOne) Where(ps ...predicate.Post) *PostUpdateOne {
	puo.mutation.Where(ps...)
	return puo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (puo *PostUpdateOne) Select(field string, fields ...string) *PostUpdateOne {
	puo.fields = append([]string{field}, fields...)
	return puo
}

// Save executes the query and returns the updated Post entity.
func (puo *PostUpdateOne) Save(ctx context.Context) (*Post, error) {
	puo.defaults()
	return withHooks[*Post, PostMutation](ctx, puo.sqlSave, puo.mutation, puo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (puo *PostUpdateOne) SaveX(ctx context.Context) *Post {
	node, err := puo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (puo *PostUpdateOne) Exec(ctx context.Context) error {
	_, err := puo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (puo *PostUpdateOne) ExecX(ctx context.Context) {
	if err := puo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (puo *PostUpdateOne) defaults() {
	if _, ok := puo.mutation.UpdatedAt(); !ok {
		v := post.UpdateDefaultUpdatedAt()
		puo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (puo *PostUpdateOne) check() error {
	if v, ok := puo.mutation.Image(); ok {
		if err := post.ImageValidator(v); err != nil {
			return &ValidationError{Name: "image", err: fmt.Errorf(`ent: validator failed for field "Post.image": %w`, err)}
		}
	}
	if v, ok := puo.mutation.Content(); ok {
		if err := post.ContentValidator(v); err != nil {
			return &ValidationError{Name: "content", err: fmt.Errorf(`ent: validator failed for field "Post.content": %w`, err)}
		}
	}
	if v, ok := puo.mutation.ProfileDisplayname(); ok {
		if err := post.ProfileDisplaynameValidator(v); err != nil {
			return &ValidationError{Name: "profile_displayname", err: fmt.Errorf(`ent: validator failed for field "Post.profile_displayname": %w`, err)}
		}
	}
	if _, ok := puo.mutation.PostedByID(); puo.mutation.PostedByCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Post.posted_by"`)
	}
	return nil
}

func (puo *PostUpdateOne) sqlSave(ctx context.Context) (_node *Post, err error) {
	if err := puo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(post.Table, post.Columns, sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt))
	id, ok := puo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Post.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := puo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, post.FieldID)
		for _, f := range fields {
			if !post.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != post.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := puo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := puo.mutation.Image(); ok {
		_spec.SetField(post.FieldImage, field.TypeString, value)
	}
	if value, ok := puo.mutation.Content(); ok {
		_spec.SetField(post.FieldContent, field.TypeString, value)
	}
	if value, ok := puo.mutation.ProfileDisplayname(); ok {
		_spec.SetField(post.FieldProfileDisplayname, field.TypeString, value)
	}
	if value, ok := puo.mutation.ProfileBirthYear(); ok {
		_spec.SetField(post.FieldProfileBirthYear, field.TypeInt16, value)
	}
	if value, ok := puo.mutation.AddedProfileBirthYear(); ok {
		_spec.AddField(post.FieldProfileBirthYear, field.TypeInt16, value)
	}
	if puo.mutation.ProfileBirthYearCleared() {
		_spec.ClearField(post.FieldProfileBirthYear, field.TypeInt16)
	}
	if value, ok := puo.mutation.ProfileGender(); ok {
		_spec.SetField(post.FieldProfileGender, field.TypeString, value)
	}
	if puo.mutation.ProfileGenderCleared() {
		_spec.ClearField(post.FieldProfileGender, field.TypeString)
	}
	if value, ok := puo.mutation.Coordinates(); ok {
		_spec.SetField(post.FieldCoordinates, field.TypeOther, value)
	}
	if value, ok := puo.mutation.CreatedAt(); ok {
		_spec.SetField(post.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := puo.mutation.UpdatedAt(); ok {
		_spec.SetField(post.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := puo.mutation.DeletedAt(); ok {
		_spec.SetField(post.FieldDeletedAt, field.TypeTime, value)
	}
	if puo.mutation.DeletedAtCleared() {
		_spec.ClearField(post.FieldDeletedAt, field.TypeTime)
	}
	if puo.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedChatRoomsIDs(); len(nodes) > 0 && !puo.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.ChatRoomsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.PostedByCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.PostedByTable,
			Columns: []string{post.PostedByColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.PostedByIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.PostedByTable,
			Columns: []string{post.PostedByColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.LikedByCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedLikedByIDs(); len(nodes) > 0 && !puo.mutation.LikedByCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.LikedByIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.ReplyToEdgeCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.ReplyToEdgeTable,
			Columns: []string{post.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.ReplyToEdgeIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.ReplyToEdgeTable,
			Columns: []string{post.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedRepliesIDs(); len(nodes) > 0 && !puo.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RepliesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Post{config: puo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, puo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{post.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	puo.mutation.done = true
	return _node, nil
}
